<!doctype html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>Asynchronous I/O with Boost.Asio</title>

    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/black.css">

    <!-- Theme used for syntax highlighting of code -->
    <link rel="stylesheet" href="lib/css/zenburn.css">

    <!-- Printing and PDF exports -->
    <script>
      var link = document.createElement( 'link' );
      link.rel = 'stylesheet';
      link.type = 'text/css';
      link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
      document.getElementsByTagName( 'head' )[0].appendChild( link );
    </script>
  </head>
  <body>
    <div class="reveal">
      <div class="slides">
        <section>
          Asynchronous I/O with Boost.Asio
        </section>

        <section>
          General Stuff
          <p>
            <ul>
              <li>since 1.35.0, March 2008</li>
              <li>header only library</li>
              <li>-lboost_system</li>
              <li>-lboost_coroutine</li>
              <li>coroutines support since 1.54.0</li>
            </ul>
          </p>
        </section>

        <section>
          General Stuff
          <p>
            <ul>
              <li>started with high-performance networking in mind</li>
              <li>timers</li>
              <li>everything that can be waited on</li>
              <ul>
                <li>file descriptors</li>
                <li>OS objects</li>
                <li>resolve a domain name</li>
              </ul>
            </ul>
          </p>
        </section>

        <section>
          References
          <p>
            https://theboostcpplibraries.com/
            <img src="pics/book.jpg" alt="Boost Book" style="width: 40%"/>
          </p>
        </section>

        <section>
          References
          <p>
            http://www.boost.org/doc/libs/1_63_0/doc/html/boost_asio.html
          </p>
        </section>

        <section>
          Foundation
          <p>
            Event loops vs. threads
          </p>

            <aside class="notes">
              <p>From Sam Robert's talk at Node.js Interactive North America</p>

              <p>
                Interview questions, e.g. on node
                <ul>
                  <li>what is an event loop?</li>
                  <li>is node single or multi threaded?</li>
                  <li>why is node said to "scale well"?</li>
                </ul>
              </p>
            </aside>
        </section>

        <section>
          <p>
            Network connections use sockets, named after a system call that is
            used to create them:
            <pre class="highlight cpp" data-trim>

            int sock = socket();

            </pre>
            <aside class="notes">

            Whats a socket?

            <ul>
              <li>A file descriptor.</li>
              <li>An abstract handle to a resource.</li>
              <li>Really just a number into the process' file table:</li>

              <li>Integer offset into an array that is kept in the kernel.</li>
              <li>Every process has an array of file descriptors.</li>
              <li>That array then has a pointer to an object which is the open control
              block (OCB) for whichever resource is attached to the file descriptor</li>
              <li>and that has a pointer to a virtual function table.</li>

              <li>OS's way to do "object orientation", one interface, different
              implementations.</li>
              <li>You can read/write/close/poll etc on it.</li>
            </ul>

            </aside>
          </p>
        </section>


        <!-- TODO: use select() in following examples, not epoll
        -->

        <section>
          Scalability Problem:
          <p>
            One thread-per-connection.
            <pre class="highlight cpp" data-trim>
    int server = socket();
    bind(server, 80);
    listen(server);
    <span class="fragment zoom-in">
    while (int client = accept(server)) {
      std::thread([client]() {
    </span>
    <span class="fragment zoom-in">
        while (int size = read(client, buf, sizeof buf)) {
          write(client, buf, size);
        }
      });
    </span>
    }
            </pre>
          </p>

            <aside class="notes">

              Once you call listen, it will accept connections. Before that it
              can be used as either side.

              <ul>
                <li>accept() is a new system call</li>
                <li>system calls can block</li>
                <li>system call: your program asks the kernel to do something</li>
                <li>when for some reason kernel cannot proceed or the kernel
                  needs to do something that takes a little bit more time, it
                  will block</li>
                <li>kernel will de-schedule your process</li>
                <li>we will not get any CPU</li>
                <li>until some resource is ready, we get re-scheduled again</li>

                <li>typical one-thread per client</li>
                <li>modern OSs can easily give you a few 1000 threads</li>
                <li>threads are heavy weight</li>
                <li>doesn't scale to tens of thousands of connections</li>
              </ul>
            </aside>
          </p>
        </section>

        <section>
          Solution to the Problem: IOCP, epoll, kqueue
          <p>
            <pre class="highlight cpp" data-trim>
    int server = socket();
    bind(server, 80);
    listen(server);
    <span class="fragment zoom-in">
    int epollfd = epoll_create1(0);
    struct epoll_event ev = {
      .events = EPOLLIN, .data.fd = server
    };
    epoll_ctl(epollfd, EPOLL_CTL_ADD, server, &ev);
    </span>
            </pre>
          </p>

          <aside class="notes">
                <li>Windows Overlapped I/O</li>
                <li>BSD or macOS kqueue</li>
                <li>Linux's epoll</li>
                <li>Or in general, POSIX select</li>
                <li>we get notified about incoming TCP connections</li>
          </aside>
        </section>

        <section>
          Solution to the Problem: IOCP, epoll, kqueue
          <p>
            <pre class="highlight cpp" data-trim>
    struct epoll_event events[10];
    while (int max = epoll_wait(epollfd, events, 10)) {
    <span class="fragment zoom-in">
      for (n = 0; n < max; n++) {
        if (events[n].data.fd.fd == server {
          int client = accept(server);
          ev.events = EPOLLIN;
          ev.data.fd = client;
          epoll_ctl(epollfd, EPOLL_CTL_ADD, client, &ev);
        }
        else {
          // ...
        }
      }
    }
    </span>
            </pre>
          </p>

            <aside class="notes">

              <ul>
                <li>this is the event loop</li>
                <li>epoll_wait() blocks until...</li>
                <li>something interesting happens the kernel will wake us up</li>

                <li>a new incoming TCP connection</li>
                <li>or a client send us something</li>
                <li>and that is the other part of the loop</li>
              </ul>
            </aside>
        </section>

        <section>
          Solution to the Problem: IOCP, epoll, kqueue
          <p>
            <pre class="highlight cpp" data-trim>
    while (int max = epoll_wait(epollfd, events, 10)) {
      for (n = 0; n < max; n++) {
          // ...
    <span class="fragment zoom-in">
        else {
          char buf[4096];
          int size = read(client, buf, sizeof buf);
          write(client, buf, size);
        }
      }
    }
    </span>
            </pre>
          </p>

            <aside class="notes">

              <ul>
                <li>when data is available on a specific TCP connection</li>
                <li>we do echo like before</li>
                <li>actually more complex because we cannot write immediately</li>
                <li>we have to remember the buffered data somewhere</li>
                <li>and register a new event for when the socket is writable again</li>
                <li>and the enter the loop again</li>
                <li>pull out the data and write it to the socket</li>
              </ul>
            </aside>
        </section>

        <section>
          <p>
            We shouldn't do this ourselves. We should use some library instead.
          </p>
        </section>

        <section>
          <p>
            Like Boost.Asio
          </p>
        </section>

        <section>
          Another Explanation Approach
          <p>
            Differentiation between internal and external resources.
          </p>
        </section>

        <section>
          Internal Resources
          <p>
            <ul>
              <li>CPU threads are used to do something in parallel</li>
              <li>computation</li>
              <li>and are internal resources from the viewpoint of your program</li>
              <li>you use std::thread or Boost.Thread for it</li>
            </ul>
          </p>

          <aside class="notes">

            <ul>
              <li>when data is available on a specific TCP connection</li>
            </ul>
          </aside>
        </section>

        <section>
          External Resources
          <p>
             <ul>
               <li>doing network IO is using the network hardware, an external resource</li>
               <li>waiting</li>
               <li>your programs hands off a pointer to the data that needs to be transmitted to the network hardware</li>
               <li>that hardware does all the work so your program can do something else</li>
               <li>for external resources you use Boost.Asio</li>
            </ul>
          </p>
          <aside class="notes">

            <ul>
              <li>External resources are best explained with using the network</li>
            </ul>
          </aside>
        </section>

        <section>
          Asynchronous Operations
          <p>
            <ul>
              <li>think of a function that you call</li>
              <li>but that function returns immediately</li>
              <li>without returning a value right away</li>
              <li>or even being finished with the work</li>
            </ul>
          </p>
        </section>

        <section>
          API
          <p>
            Differentiation between IO service object and IO objects
            <ul>
              <li>one (or multiple) IO service</li>
              <li>multiple IO objects</li>
            </ul>
          </p>

          <aside class="notes">
            <ul>
              <li>IO service provides the basic IO functionality, the event
                loop as you will</li>
              <li>different IO objects</li>
              <li>depends on the task at hand, socket, serial port, timer</li>
            </ul>
          </aside>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example1.cpp" data-trim></pre>

          <aside class="notes">
            Example 1:

            timer.async_wait is non-blocking, handler function, service.run
            however blocks. When does run return? As soon as no IO operations are
            waiting/pending anymore.

          </aside>
        </section>

        <section>
          <p>
          When does io_service::run() return?
          </p>

          <p class="fragment zoom-in">
            A call to io_service::run() blocks while there are unfinished asynchronous operations.
          </p>

          <aside class="notes">
          </aside>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example2.cpp" data-trim></pre>

          <aside class="notes">
            Example 2: same but with two timers/operations
          </aside>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example3.cpp" data-trim></pre>

          <aside class="notes">
            Example 3: with threads
          </aside>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example4.cpp" data-trim></pre>

        <aside class="notes">
          Example 4: with threads and multiple IO objects
        </aside>
        </section>

        <section>
          Strand
          <p>
          Using threads without explicit locking.
          </p>
          <p>
            <pre class="highlight cpp" data-trim>
io_service::strand strand(service);
// ...
timer1.async_wait(
    strand.wrap([](const auto &error_code) {
      // ...
    });
);
            </pre>
          </p>

          <aside class="notes">
            <ul>
              <li>Closer look at previous example, timers firing at the same time</li>
              <li>How do we do synchronization?</li>
              <li>You might be tempted to use std::mutex or whatever primitives you know</li>
              <li>Don't do that</li>
              <li>Use the constructs the library provides</li>
              <li>Ensures that only one completion handler that is wrapped by
                the same strand will run at the same time</li>
              <li>Examples: stdout, write to a TCP socket</li>
            </ul>
          </aside>
        </section>

        <section>
          Buffer
          <p>
            <pre class="highlight cpp" data-trim>
typedef std::pair&lt;void*, std::size_t> mutable_buffer;
typedef std::pair&lt;const void*, std::size_t> const_buffer;
            </pre>
          </p>
          <p>
            <ul>
              <li>Does not own underlying data</li>
              <li>mutable buffers can be converted to const buffers</li>
              <li>Asio supports scatter/gather when buffers are stored into containers</li>
          </p>

          <aside class="notes">

            <ul>
              <li>Briefly</li>
              <li>Dealing with memory</li>
              <li>Your application owns the data</li>
              <li>A view into data</li>
              <li>Of course, convert mutable buffers into const buffers</li>

              <li>Scatter/Gather: several buffers stored into a container</li>
              <li>A scatter-read receives data into multiple buffers</li>
              <li>A gather-write transmits multiple buffers</li>
            </ul>
          </aside>
        </section>

        <section>
            <pre class="highlight cpp" data-trim>
std::array&lt;uint8_t, 4> code = { 0x00, 0xfe, 0xfe, 0x03 };
socket.send(buffer(code));

            </pre>
        </section>

        <section>
          Boost.Asio for Network Programming
          <p>
            boost::asio::ip::tcp::socket
          </p>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example5.cpp" data-trim></pre>

          <aside class="notes">
            Example 5: Single HTTP GET request
          </aside>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example6.cpp" data-trim></pre>

          <aside class="notes">
            Example 6: A time server with boost::asio::ip::tcp::acceptor

            <ul>
              <li>accept incoming TCP connection</li>
            </ul>
          </aside>
        </section>

        <section>
          Coroutines
          <p>
          Why?
        <!-- TODO -->
          spawn() function is a high-level wrapper over the Boost.Coroutine library
          </p>
        </section>

        <section>
          <pre class="stretch highlight cpp" data-code="code/example7.cpp" data-trim></pre>

          <aside class="notes">
            Example 7: Re-write of time server with coroutines
          </aside>
        </section>

        <section>
          Platform-specific IO objects
          <p>
            boost::asio::{asio,posix}
          </p>
          <p>
            e.g., a file system watcher with windows::overlapped_ptr and Win32
            ReadDirectoryChanges.
          </p>
        </section>

        <!--

          TODO

        Maybe example8 watch file system with boost::asio::windows::object_handle

        Maybe example10 with boost::asio::posix::stream_descriptor to write to
        stdout asynchronously.

        Maybes
        service.post() essentially a thread pool

        Workshop
        Prepare git repo to clone for everyone
        Jörn's repo or a little chat server?

        -->

        <section>
          Advantages
          <p>
            <ul>
              <li>Portability</li>
              <li>Decoupling threading from concurrency</li>
              <li>Performance and scalability</li>
              <li>No synchronization</li>
            </ul>
          </p>

          <aside class="notes">

            <ul>
              <li>Many operating systems offer a native asynchronous I/O API
                (such as overlapped I/O on Windows) as the preferred option for
                developing high performance network applications</li>
              <li>No need to spawn many threads in order to increase
                concurrency</li>
              <li>thread-per-connection can degrade system performance, due to
                increased context switching, synchronization and data movement
                among CPUs. With asynchronous operations it is possible to
                avoid the cost of context switching by minimizing the number of
                operating system threads</li>
            </ul>
          </aside>
        </section>

        <section>
          Disadvantages
            <ul>
              <li>New approach with its own complexities</li>
              <li>Inverted flow of control</li>
            </ul>

          <aside class="notes">
                 It is more difficult to develop applications using
                 asynchronous mechanisms due to the separation in time and
                 space between operation initiation and completion.
                 Applications may also be harder to debug due to the inverted
                 flow of control
          </aside>
        </section>

        <section>
          Questions

          <aside class="notes">

            Boost.Asio and testing?

          </aside>
        </section>

        <section>
          Chat server?

          <!-- interesting problem here: who owns the client handler?
            Like the ClientManager class in my workd example.
          -->
        </section>

      </div>
    </div>

    <script src="lib/js/head.min.js"></script>
    <script src="js/reveal.js"></script>

    <script>
      // More info https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        history: true,

        // More info https://github.com/hakimel/reveal.js#dependencies
        dependencies: [
          { src: 'plugin/markdown/marked.js' },
          { src: 'plugin/markdown/markdown.js' },
          { src: 'plugin/notes/notes.js', async: true },
          { src: 'plugin/highlight/highlight.js', async: true, callback: function() {
            [].forEach.call(document.querySelectorAll('.highlight'),
                function(v, i) { hljs.highlightBlock(v); });
            }
          },
          { src: 'plugin/externalcode/externalcode.js', condition: function() {
            return !!document.querySelector( '[data-code]' ); }
          }
        ]
      });

      // Shows the slide number using default formatting
      Reveal.configure({ slideNumber: true });
    </script>
  </body>
</html>
